using System.Drawing;

namespace Dashboard.Windowing
{
    /// <summary>
    /// Generic interface for the rendering system present in a <see cref="IPhysicalWindow"/>
    /// </summary>
    public interface IDeviceContext
    {
        /// <summary>
        /// The swap group for this device context.
        /// </summary>
        ISwapGroup SwapGroup { get; }

        /// <summary>
        /// The size of the window framebuffer in pixels.
        /// </summary>
        Size FramebufferSize { get; }
    }
}